/*************************************************  Product Functions Header  **************************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright (c) 2019  Red Rapids, Inc.

	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
	modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
	is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
	LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
	IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*************************************************  Product Functions Header  **************************************************/

#ifndef _PRODUCT_FUNCTIONS_H_
#define _PRODUCT_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

// Structure to reference all of the device configuration settings for a Model 370.
typedef struct
{
	s_ADC12D1600 RX1_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_ADL5566 RX1_AMP_ENBL;
} s_M370Devices;

// Structure to reference all of the device configuration settings for a Model 371.
typedef struct
{
	s_AD9512 ClockDist;
	s_ADS42LB69 RX1TO2_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_ADL5566 RX1TO2_AMP_ENBL;
	s_ADF4110 Synthesizer;
} s_M371Devices;

// Structure to reference all of the device configuration settings for a Model 372.
typedef struct
{
	s_LMK01000 ClockDist;
	s_AD9652 RX1TO2_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_ADA4927 RX1_AMP_ENBL;
	s_ADA4927 RX2_AMP_ENBL;
	s_AD9142A TX3TO4_DAC;
	s_LTC1661 TX3_TRIM_DAC;
	s_LTC1661 TX4_TRIM_DAC;
	s_AD8000 TX3_AMP_ENBL;
	s_AD8000 TX4_AMP_ENBL;
	s_PROGSYNTH PROG_SYNTH;
} s_M372Devices;

// Structure to reference all of the device configuration settings for a Model 373.
typedef struct
{
	s_LMK01000 ClockDist;
	s_AD9652 RX1TO2_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_ADA4927 RX1_AMP_ENBL;
	s_ADA4927 RX2_AMP_ENBL;
	s_PROGSYNTH PROG_SYNTH;
} s_M373Devices;

// Structure to reference all of the device configuration settings for a Model 376.
typedef struct
{
	s_ADC12D1600 RX1TO2_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_ADL5566 RX1TO2_AMP_ENBL;
} s_M376Devices;

// Structure to reference all of the device configuration settings for a Model 377.
typedef struct
{
	s_AD9512 ClockDist;
	s_ADS42LB69 RX1TO2_ADC;
	s_ADS42LB69 RX3TO4_ADC;
	s_LTC1661 RX1_TRIM_DAC;
	s_LTC1661 RX2_TRIM_DAC;
	s_LTC1661 RX3_TRIM_DAC;
	s_LTC1661 RX4_TRIM_DAC;
	s_ADL5566 RX1TO2_AMP_ENBL;
	s_ADL5566 RX3TO4_AMP_ENBL;
	s_ADF4110 Synthesizer;
} s_M377Devices;

// Structure to reference all of the device configuration settings for a Model 378.
typedef struct
{
	s_LMK01000 ClockDist;
	s_AD9653 RX1TO4_ADC;
	s_AD9653 RX5TO8_ADC;
	s_AD9653 RX1TO4_TRIM_DAC;
	s_AD9653 RX5TO8_TRIM_DAC;
	s_ADA4927 RX1TO2_AMP_ENBL;
	s_ADA4927 RX3TO4_AMP_ENBL;
	s_ADA4927 RX5TO6_AMP_ENBL;
	s_ADA4927 RX7TO8_AMP_ENBL;
	s_PROGSYNTH PROG_SYNTH;
} s_M378Devices;

// Prototypes for each of the device functions.
int HWInitialize(s_Handle *p_HW, unsigned Model);
int M370Initialize(s_Handle *p_HW, s_M370Devices M370Devices);
int M371Initialize(s_Handle *p_HW, s_M371Devices M371Devices);
int M372Initialize(s_Handle *p_HW, s_M372Devices M372Devices);
int M373Initialize(s_Handle *p_HW, s_M373Devices M373Devices);
int M376Initialize(s_Handle *p_HW, s_M376Devices M376Devices);
int M377Initialize(s_Handle *p_HW, s_M377Devices M377Devices);
int M378Initialize(s_Handle *p_HW, s_M378Devices M378Devices);

#ifdef __cplusplus
}
#endif

#endif
